package fr.umlv.lgextract.tools;

import java.util.Map;

import fr.umlv.tatoo.runtime.ast.Node;
import fr.umlv.tatoo.runtime.ast.NodeVisitor;

public class Visitor<_R,_P,_D,_E extends Throwable> extends NodeVisitor<_R,_P,_D,_E>{
  public Visitor() {
    super();
  }
  public Visitor(Map<Node,_D> dataMap) {
    super(dataMap);
  }
  public _R visit(Prop prop,_P param) throws _E {
       return visit((Node)prop,param);
     }
  public _R visit(Header_Module header_module,_P param) throws _E {
       return visit((Node)header_module,param);
     }
  public _R visit(Information_Star information_star,_P param) throws _E {
       return visit((Node)information_star,param);
     }
  public _R visit(Instruction_Star instruction_star,_P param) throws _E {
       return visit((Node)instruction_star,param);
     }
  public _R visit(Several_Features several_features,_P param) throws _E {
       return visit((IFeatures)several_features,param);
     }
  public _R visit(Value_Id value_id,_P param) throws _E {
       return visit((IBoolvalue)value_id,param);
     }
  public _R visit(Feature_Value feature_value,_P param) throws _E {
       return visit((IFeature)feature_value,param);
     }
  public _R visit(Infos infos,_P param) throws _E {
       return visit((Node)infos,param);
     }
  public _R visit(ActionInstruction actionInstruction,_P param) throws _E {
       return visit((IInstruction)actionInstruction,param);
     }
  public _R visit(Parenthesis parenthesis,_P param) throws _E {
       return visit((IBoolexp)parenthesis,param);
     }
  public _R visit(Propactionname_Always propactionname_always,_P param) throws _E {
       return visit((IActionname)propactionname_always,param);
     }
  public _R visit(OtherPropCall otherPropCall,_P param) throws _E {
       return visit((IInstruction)otherPropCall,param);
     }
  public _R visit(List list,_P param) throws _E {
       return visit((IList)list,param);
     }
  public _R visit(Feature_Name feature_name,_P param) throws _E {
       return visit((IFeature)feature_name,param);
     }
  public _R visit(Create create,_P param) throws _E {
       return visit((IAction)create,param);
     }
  public _R visit(Value_Bool value_bool,_P param) throws _E {
       return visit((IBoolvalue)value_bool,param);
     }
  public _R visit(Define_Star define_star,_P param) throws _E {
       return visit((Node)define_star,param);
     }
  public _R visit(And and,_P param) throws _E {
       return visit((IBoolexp)and,param);
     }
  public _R visit(Add_Conditional add_conditional,_P param) throws _E {
       return visit((IAction)add_conditional,param);
     }
  public _R visit(Feature_Fs feature_fs,_P param) throws _E {
       return visit((IFeature)feature_fs,param);
     }
  public _R visit(Obj_Feature obj_feature,_P param) throws _E {
       return visit((ILingobj)obj_feature,param);
     }
  public _R visit(Not not,_P param) throws _E {
       return visit((IBoolexp)not,param);
     }
  public _R visit(Create_Conditional create_conditional,_P param) throws _E {
       return visit((IAction)create_conditional,param);
     }
  public _R visit(Obj_Fs obj_fs,_P param) throws _E {
       return visit((ILingobj)obj_fs,param);
     }
  public _R visit(Prop_Value prop_value,_P param) throws _E {
       return visit((IBoolvalue)prop_value,param);
     }
  public _R visit(Add add,_P param) throws _E {
       return visit((IAction)add,param);
     }
  public _R visit(Attrib attrib,_P param) throws _E {
       return visit((Node)attrib,param);
     }
  public _R visit(Feature_List feature_list,_P param) throws _E {
       return visit((IFeature)feature_list,param);
     }
  public _R visit(Fs_Simple fs_simple,_P param) throws _E {
       return visit((IFs)fs_simple,param);
     }
  public _R visit(Value value,_P param) throws _E {
       return visit((IBoolexp)value,param);
     }
  public _R visit(Features_Feature features_feature,_P param) throws _E {
       return visit((IFeatures)features_feature,param);
     }
  public _R visit(Propactionname propactionname,_P param) throws _E {
       return visit((IActionname)propactionname,param);
     }
  public _R visit(Empty_List empty_list,_P param) throws _E {
       return visit((IList)empty_list,param);
     }
  public _R visit(Not_Propactionname not_propactionname,_P param) throws _E {
       return visit((IActionname)not_propactionname,param);
     }
  public _R visit(Define define,_P param) throws _E {
       return visit((Node)define,param);
     }
  public _R visit(Simplefs simplefs,_P param) throws _E {
       return visit((ISimplefs)simplefs,param);
     }
  public _R visit(OtherActionName otherActionName,_P param) throws _E {
       return visit((IActionname)otherActionName,param);
     }
  public _R visit(Or or,_P param) throws _E {
       return visit((IBoolexp)or,param);
     }
  public _R visit(Empty_Simplefs empty_simplefs,_P param) throws _E {
       return visit((ISimplefs)empty_simplefs,param);
     }
  public _R visit(Simple_Path simple_path,_P param) throws _E {
       return visit((IPath)simple_path,param);
     }
  public _R visit(Att_Star att_star,_P param) throws _E {
       return visit((Node)att_star,param);
     }
  public _R visit(Start start,_P param) throws _E {
       return visit((Node)start,param);
     }
  public _R visit(Element_Star element_star,_P param) throws _E {
       return visit((Node)element_star,param);
     }
  public _R visit(Feature_Fs_Inherits feature_fs_inherits,_P param) throws _E {
       return visit((IFeature)feature_fs_inherits,param);
     }
  public _R visit(Elem elem,_P param) throws _E {
       return visit((Node)elem,param);
     }
  public _R visit(Several_Path several_path,_P param) throws _E {
       return visit((IPath)several_path,param);
     }
  public _R visit(Obj_List obj_list,_P param) throws _E {
       return visit((ILingobj)obj_list,param);
     }
  public _R visit(Fs_Inherits fs_inherits,_P param) throws _E {
       return visit((IFs)fs_inherits,param);
     }
  public _R visit(Info info,_P param) throws _E {
       return visit((Node)info,param);
     }
  public _R visit(Property_Star property_star,_P param) throws _E {
       return visit((Node)property_star,param);
     }
   protected _R visit(IActionname actionname,_P param) throws _E {
    return visit((Node)actionname,param);
  }
    protected _R visit(IAction action,_P param) throws _E {
    return visit((Node)action,param);
  }
    protected _R visit(IFs fs,_P param) throws _E {
    return visit((Node)fs,param);
  }
    protected _R visit(IBoolvalue boolvalue,_P param) throws _E {
    return visit((Node)boolvalue,param);
  }
    protected _R visit(IFeature feature,_P param) throws _E {
    return visit((Node)feature,param);
  }
    protected _R visit(IInstruction instruction,_P param) throws _E {
    return visit((Node)instruction,param);
  }
    protected _R visit(IFeatures features,_P param) throws _E {
    return visit((Node)features,param);
  }
    protected _R visit(IPath path,_P param) throws _E {
    return visit((Node)path,param);
  }
    protected _R visit(IList list,_P param) throws _E {
    return visit((Node)list,param);
  }
    protected _R visit(ISimplefs simplefs,_P param) throws _E {
    return visit((Node)simplefs,param);
  }
    protected _R visit(IBoolexp boolexp,_P param) throws _E {
    return visit((Node)boolexp,param);
  }
    protected _R visit(ILingobj lingobj,_P param) throws _E {
    return visit((Node)lingobj,param);
  }
 }
