/**
 * 
 *
 * Software: LGExtract
 * Authors: Matthieu Constant and Elsa Tolone
 *
 * Copyright (C) 2010-2011 Université Paris-Est Marne-la-Vallée
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 *
 */
package fr.umlv.lgextract.table;


/**
 * @author Matthieu Constant
 *
 */
public class LGCsvEntry extends LGAbstractNormalTableEntry {
    final private String[] cells;
    
	public LGCsvEntry(int rowId, String[] cells,LGTable<?> table,boolean debug) {
		super(rowId, table,debug);
		this.cells = cells;

	}

	@Override
	protected String getCellValue(int col) {
		//System.err.println(cells.toString());
		/*for(String x:cells){
			System.err.print(" "+x);
		}*/
		//System.err.println();
		String val = cells[col];
		if(val.isEmpty()){
			return val;
		}
		return val.substring(1, val.length() - 1);
	}
	
	
}
